//
//  LoginView.m
//  DemoAlivcLive
//
//  Created by LYZ on 16/8/22.
//  Copyright © 2016年 Alivc. All rights reserved.
//

#import "AddDownloadView.h"
#import "DownLoadDataHeader.h"

@implementation AddDownloadView

- (instancetype)initWithFrame:(CGRect)frame
{
    self = [super initWithFrame:frame];
    if (self) {
        
        UIControl *control = [[UIControl alloc]initWithFrame:self.bounds];
        [control addTarget:self action:@selector(hidekeybroad:) forControlEvents:UIControlEventTouchDown];
        [self addSubview:control];
        
        
        UILabel *appKeyLabel = [[UILabel alloc] init];
        [appKeyLabel setFrame:CGRectMake(10, 40, 120, 30)];
        [appKeyLabel setText:@"vid: "];
        [appKeyLabel setTextColor:[UIColor blackColor]];
        [self addSubview:appKeyLabel];
        
        _textVid = [[UITextField alloc] init];
        [_textVid setFrame:CGRectMake(100, 35, 180, 30)];
        [_textVid setText:DOWNLOAD_VID];
        _textVid.font = [UIFont systemFontOfSize:12.0f];
        [_textVid setTextColor:[UIColor blackColor]];
        [_textVid setBorderStyle:UITextBorderStyleRoundedRect];
        [self addSubview:_textVid];
        
        UILabel *appSecretLabel = [[UILabel alloc] init];
        [appSecretLabel setFrame:CGRectMake(10, 77, 120, 30)];
        [appSecretLabel setText:@"playAuth: "];
        [appSecretLabel setTextColor:[UIColor blackColor]];
        [self addSubview:appSecretLabel];
        
        _textView = [[UITextView alloc] init];
        _textView.frame = CGRectMake(10, 110, self.frame.size.width-20, 90);
        _textView.textColor = [UIColor blackColor];
        _textView.backgroundColor = [UIColor whiteColor];
        _textView.font = [UIFont systemFontOfSize:12.0f];
        _textView.textAlignment = NSTextAlignmentLeft;
        _textView.textContainerInset = UIEdgeInsetsMake(20, 20, 20, 20);
        _textView.layer.cornerRadius = 5;
        _textView.layer.masksToBounds = YES;
        _textView.text = DOWNLOAD_PLAY_AUTH;
        [self addSubview:_textView];
        
        _backBtn = [UIButton buttonWithType:(UIButtonTypeRoundedRect)];
        _backBtn.frame = CGRectMake(40, 325, 100, 40);
        [_backBtn addTarget:self action:@selector(cancelBtnAction:) forControlEvents:(UIControlEventTouchUpInside)];
        [_backBtn setTitleColor:[UIColor colorWithRed:123 / 255.0 green:134 / 255.0 blue:252 / 255.0 alpha:1] forState:(UIControlStateNormal)];
        [_backBtn setTitleColor:[UIColor grayColor] forState:(UIControlStateSelected)];
        [_backBtn.titleLabel setFont:[UIFont systemFontOfSize:17.f]];
        [_backBtn setBackgroundColor:[UIColor colorWithRed:0x87 / 255.0 green:0x4b / 255.0 blue:0xe0 / 255.0 alpha:1]];
        [_backBtn setTitle:@"取消" forState:UIControlStateNormal];
        _backBtn.clipsToBounds = YES;
        _backBtn.layer.cornerRadius = 20;
        [_backBtn setTitleColor:[UIColor whiteColor] forState:UIControlStateNormal];
        [self addSubview:_backBtn];
        
        _okBtn = [UIButton buttonWithType:(UIButtonTypeRoundedRect)];
        _okBtn.frame = CGRectMake(160, 325, 100, 40);
        [_okBtn addTarget:self action:@selector(okBtnAction:) forControlEvents:(UIControlEventTouchUpInside)];
        [_okBtn setTitleColor:[UIColor colorWithRed:123 / 255.0 green:134 / 255.0 blue:252 / 255.0 alpha:1] forState:(UIControlStateNormal)];
        [_okBtn setTitleColor:[UIColor grayColor] forState:(UIControlStateSelected)];
        [_okBtn.titleLabel setFont:[UIFont systemFontOfSize:17.f]];
        [_okBtn setBackgroundColor:[UIColor colorWithRed:0x87 / 255.0 green:0x4b / 255.0 blue:0xe0 / 255.0 alpha:1]];
        [_okBtn setTitle:@"添加" forState:UIControlStateNormal];
        _okBtn.clipsToBounds = YES;
        _okBtn.layer.cornerRadius = 20;
        [_okBtn setTitleColor:[UIColor whiteColor] forState:UIControlStateNormal];
        [self addSubview:_okBtn];
        
        self.backgroundColor = [UIColor lightGrayColor];
        self.layer.cornerRadius = 8;
        self.layer.masksToBounds = YES;
        self.layer.borderWidth = 1;
        
        _qualityBtn = [UIButton buttonWithType:(UIButtonTypeRoundedRect)];
        _qualityBtn.frame = CGRectMake(10, 225, 100, 30);
        [_qualityBtn addTarget:self action:@selector(qualityRequest:) forControlEvents:(UIControlEventTouchUpInside)];
        [_qualityBtn setTitleColor:[UIColor colorWithRed:123 / 255.0 green:134 / 255.0 blue:252 / 255.0 alpha:1] forState:(UIControlStateNormal)];
        [_qualityBtn setTitleColor:[UIColor grayColor] forState:(UIControlStateSelected)];
        [_qualityBtn.titleLabel setFont:[UIFont systemFontOfSize:12.f]];
        [_qualityBtn setBackgroundColor:[UIColor colorWithRed:0x87 / 255.0 green:0x4b / 255.0 blue:0xe0 / 255.0 alpha:1]];
        [_qualityBtn setTitle:@"获取清晰度" forState:UIControlStateNormal];
        _qualityBtn.clipsToBounds = YES;
        _qualityBtn.layer.cornerRadius = 10;
        [_qualityBtn setTitleColor:[UIColor whiteColor] forState:UIControlStateNormal];
        [self addSubview:_qualityBtn];
        
        _qualityControl = nil;
        _mArray = [[NSMutableArray alloc] init];
        _delegate = nil;
        
        
    }
    
    return self;
}

-(void)hidekeybroad:(UIControl *)control
{
    [_textVid resignFirstResponder];
    [_textView resignFirstResponder];

}


- (void)qualityRequest:(UIButton *)sender {
    [self.textVid resignFirstResponder];
    [self.textView resignFirstResponder];
    
    AliyunDataSource* source = [[AliyunDataSource alloc] init];
    source.vid = _textVid.text;
    source.playAuth = _textView.text;
    
    [[AliyunVodDownLoadManager shareManager] prepareDownloadMedia:source];
}

- (void)cancelBtnAction:(UIButton *)sender {
    self.hidden = YES;
}

- (void)okBtnAction:(UIButton *)sender {
    if (_qualityControl.enabled == NO) {
        UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"提示" message:@"请先获取清晰度" delegate:nil cancelButtonTitle:@"OK" otherButtonTitles:nil];
        [alert show];
        return;
    }
    
    AliyunDownloadMediaInfo* info = [_mArray objectAtIndex:_qualityControl.selectedSegmentIndex];
    AliyunDataSource* source = [[AliyunDataSource alloc] init];
    source.vid = _textVid.text;
    source.format = info.format;
    source.quality = info.quality;
    source.playAuth = _textView.text;
    
    if (_delegate && [_delegate respondsToSelector:@selector(onStartDownload:medianInfo:)]) {
        [_delegate onStartDownload:source medianInfo:info];
    }
    self.hidden = YES;
}

-(void) initShow
{
    if (_qualityControl) {
        [_qualityControl removeFromSuperview];
        _qualityControl = nil;
    }
    
    [_mArray removeAllObjects];
}

-(void) updateQualityInfo:(NSArray<AliyunDownloadMediaInfo*>*)mediaInfos
{
    dispatch_async(dispatch_get_main_queue(), ^{

        if ([mediaInfos count]==0) {
            return;
        }
        
        if (_qualityControl) {
            [_qualityControl removeFromSuperview];
            _qualityControl = nil;
        }
        
        [_mArray removeAllObjects];
        NSMutableArray* array = [[NSMutableArray alloc] init];
        NSArray *segmentedArray = [[NSArray alloc] initWithObjects:@"流畅",@"标清",@"高清",@"超清",@"2K",@"4K",@"原画",nil];
        for (AliyunDownloadMediaInfo* info  in mediaInfos) {
            NSString* text = [segmentedArray objectAtIndex:info.quality];
            NSString* sizeStr = [[NSString alloc] initWithFormat:@"%@(%.2fM)",text,info.size*1.0f/(1024*1024)];
            [array addObject:sizeStr];
            [_mArray addObject:info];
        }
        
        if ([array count]>0) {
            _qualityControl = [[UISegmentedControl alloc]initWithItems:array];
            _qualityControl.frame = CGRectMake(20,260,250,35);
            _qualityControl.selectedSegmentIndex = 0;
            _qualityControl.tintColor = [UIColor whiteColor];
            [self addSubview:_qualityControl];
        }
    });
}

@end
