//
//  AliyunDownLoadView.m
//  AliyunPlayerMediaDemo
//
//  Created by 王凯 on 2017/8/23.
//  Copyright © 2017年 com.alibaba.ALPlayerVodSDK. All rights reserved.
//

#import "AliyunDownLoadView.h"

#define BUTTONCLICEKEDTAG    200
#define BUTTONTAG            5001
@interface AliyunDownLoadView()<UITextFieldDelegate>
    
@property (nonatomic, strong)UILabel *vidLabel;
@property (nonatomic, strong)UITextField *vidTextField;
@property (nonatomic, strong)UILabel *playAuthLabel;
@property (nonatomic, strong)UITextField *playAuthTextField;
    
@property (nonatomic, strong)UIButton *getButton;
@property (nonatomic, strong)UIButton *cancelButton;
@property (nonatomic, strong)UIButton *addButton;

@property (nonatomic, strong)UIControl *control;



@end
@implementation AliyunDownLoadView


- (UIControl *)control{
    
    if (!_control) {
        _control = [[UIControl alloc] init];
        [_control addTarget:self action:@selector(controlClicked:) forControlEvents:UIControlEventTouchUpInside];
        
    }
    return _control;


}

- (void)controlClicked : (UIControl *)sender{
    [self.vidTextField resignFirstResponder];
    [self.playAuthTextField resignFirstResponder];
}
- (UILabel *)vidLabel{
    if (!_vidLabel) {
        _vidLabel = [[UILabel alloc] init];
        _vidLabel.text = @"vid";
        _vidLabel.textAlignment = NSTextAlignmentCenter;
        _vidLabel.font = [UIFont systemFontOfSize:12.0f];
    }
    return _vidLabel;
}

- (UITextField *)vidTextField{
    if (!_vidTextField) {
        _vidTextField = [[UITextField alloc] init];
        _vidTextField.borderStyle = UITextBorderStyleRoundedRect;
//        _vidTextField.backgroundColor = [UIColor grayColor];
        _vidTextField.placeholder = @"videoID";
        _vidTextField.autocorrectionType = UITextAutocorrectionTypeYes;
        _vidTextField.delegate = self;
    }
    
    return _vidTextField;
}

- (UILabel *)playAuthLabel{
    if (!_playAuthLabel) {
        _playAuthLabel = [[UILabel alloc] init];
        _playAuthLabel.text = @"playAuth";
        _playAuthLabel.textAlignment = NSTextAlignmentCenter;
        _playAuthLabel.font = [UIFont systemFontOfSize:12.0f];
    }
    return _playAuthLabel;
}

- (UITextField *)playAuthTextField{
    if (!_playAuthTextField) {
        _playAuthTextField = [[UITextField alloc] init];
        _playAuthTextField.borderStyle = UITextBorderStyleRoundedRect;
//        _playAuthTextField.backgroundColor = [UIColor grayColor];
        _playAuthTextField.placeholder = @"playAuth";
        _playAuthTextField.autocorrectionType = UITextAutocorrectionTypeYes;
        _playAuthTextField.delegate = self;
    }
    
    return _playAuthTextField;
}

- (UIButton *)getButton{
    
    if (!_getButton) {
        _getButton = [UIButton buttonWithType:UIButtonTypeCustom];
        [_getButton setTitle:@"获取清晰度" forState:UIControlStateNormal];
        [_getButton setTitleColor:[UIColor blueColor] forState:UIControlStateNormal];
        _getButton.titleLabel.textColor = [UIColor blueColor];
        _getButton.titleLabel.font = [UIFont systemFontOfSize:12.0f];
        _getButton.titleLabel.textAlignment = NSTextAlignmentLeft;
        _getButton.tag = BUTTONCLICEKEDTAG;
        [_getButton addTarget:self action:@selector(buttonClicked:) forControlEvents:UIControlEventTouchUpInside];
        
        
    }
    return  _getButton;
    
}

- (UIButton *)cancelButton{
    if (!_cancelButton) {
        _cancelButton = [UIButton buttonWithType:UIButtonTypeCustom];
        [_cancelButton setTitle:@"取消" forState:UIControlStateNormal];
        _cancelButton.titleLabel.textColor = [UIColor blueColor];
        [_cancelButton setTitleColor:[UIColor blueColor] forState:UIControlStateNormal];
        _cancelButton.titleLabel.font = [UIFont systemFontOfSize:12.0f];
//        _cancelButton.titleLabel.textAlignment = NSTextAlignmentLeft;
        _cancelButton.tag = BUTTONCLICEKEDTAG+1;
        
        _cancelButton.layer.borderWidth = 1;
        _cancelButton.layer.masksToBounds = YES;
        _cancelButton.layer.borderColor = [UIColor grayColor].CGColor;
        
        [_cancelButton addTarget:self action:@selector(buttonClicked:) forControlEvents:UIControlEventTouchUpInside];
        
    }
    return _cancelButton;
}

- (UIButton *)addButton{
    if (!_addButton) {
        _addButton = [UIButton buttonWithType:UIButtonTypeCustom];
        [_addButton setTitle:@"确定添加" forState:UIControlStateNormal];
        [_addButton setTitleColor:[UIColor blueColor] forState:UIControlStateNormal];
        _addButton.titleLabel.textColor = [UIColor blueColor];
        _addButton.titleLabel.font = [UIFont systemFontOfSize:12.0f];
//        _addButton.titleLabel.textAlignment = NSTextAlignmentLeft;
        _addButton.tag = BUTTONCLICEKEDTAG+2;
        
        _addButton.layer.borderWidth = 1;
        _addButton.layer.masksToBounds = YES;
        _addButton.layer.borderColor = [UIColor grayColor].CGColor;
        
        [_addButton addTarget:self action:@selector(buttonClicked:) forControlEvents:UIControlEventTouchUpInside];
    }
    return _addButton;
}

- (instancetype)init{
    if (self = [super init]) {
        
    }
    
    return self;
}

- (instancetype)initWithFrame:(CGRect)frame{
    if (self = [super initWithFrame:frame]) {
    
        
    }
    return self;
}

- (void)layoutSubviews{

    CGRect frame = self.frame;
    
    self.control.frame = CGRectMake(0, 0, self.width, self.height);
    [self addSubview:self.control];
    
    self.vidLabel.frame = CGRectMake(0, 20, 50, 30);
    self.vidTextField.frame = CGRectMake(self.vidLabel.right+5, self.vidLabel.top,frame.size.width-self.vidLabel.width-5-10, 30);
    
    self.playAuthLabel.frame =CGRectMake(0, self.vidLabel.bottom+5, 50, 30);
    self.playAuthTextField.frame = CGRectMake(self.playAuthLabel.right+5, self.playAuthLabel.top, frame.size.width-self.playAuthLabel.width-5-10, 30);
    
    self.getButton.frame = CGRectMake(10, self.playAuthLabel.bottom+10, 100, 30);
    
    CGFloat width = frame.size.width/2.0;
    
    self.cancelButton.frame = CGRectMake(0, self.height-40, width, 40);
    self.addButton.frame = CGRectMake(self.cancelButton.right, self.height-40, width, 40);
    
    [self addSubview:self.vidLabel];
    [self addSubview:self.vidTextField];
    [self addSubview:self.playAuthLabel];
    [self addSubview:self.playAuthTextField];
    [self addSubview:self.getButton];
    [self addSubview:self.cancelButton];
    [self addSubview:self.addButton];

}


- (BOOL)textFieldShouldReturn:(UITextField *)textField{
    [textField resignFirstResponder];
    return YES;
}

#pragma mark - buttonClicked
- (void)buttonClicked:(UIButton *)sender{
    switch (sender.tag) {
        case BUTTONCLICEKEDTAG:
        {
            if (self.loadViewDelegate) {
                [self.loadViewDelegate aliyunDownLoadView:self button:sender];
            }
        }
        break;
        
        case BUTTONCLICEKEDTAG+1 :
        {
            
        }
        break;
        
        case BUTTONCLICEKEDTAG+2:
        {
            
        }
        break;
        
        default:
        break;
    }
    
    
    
}


- (void)getQualityLists:(NSArray *)qualityLists{
    NSArray *ary = qualityLists;
    
    CGFloat tHeight = self.getButton.bottom+20;
    CGFloat tWidth = (self.width - 20)/4.0;
    
    for (int i = 0 ; i<7; i++) {
        UIButton *btn = [UIButton buttonWithType:UIButtonTypeSystem];
        btn.titleLabel.font = [UIFont systemFontOfSize:12.0f];
        btn.frame = CGRectMake(10+i%4*tWidth, tHeight+i/4*32, tWidth, 30);
        btn.titleLabel.textColor = [UIColor blueColor];
        btn.layer.masksToBounds = YES;
        btn.layer.cornerRadius = 5.0f;
        btn.layer.borderWidth = 0.5;
        
        if ([ary containsObject:[NSString stringWithFormat:@"%d",i]]) {
            [btn setEnabled:YES];
        }else{
            [btn setEnabled:NO];
        }
        
        btn.layer.borderColor = [UIColor blueColor].CGColor;
        btn.tag  = BUTTONTAG+i;
        switch (btn.tag) {
            case 5001:
                [btn setTitle:@"流畅" forState:UIControlStateNormal];
                break;
            case 5002:
                [btn setTitle:@"标清" forState:UIControlStateNormal];
                break;
            case 5003:
                [btn setTitle:@"高清" forState:UIControlStateNormal];
                break;
            case 5004:
                [btn setTitle:@"超清" forState:UIControlStateNormal];
                break;
                
            case 5005:
                [btn setTitle:@"2K" forState:UIControlStateNormal];
                break;
            case 5006:
                [btn setTitle:@"4K" forState:UIControlStateNormal];
                break;
                
            case 5007:
                [btn setTitle:@"原画" forState:UIControlStateNormal];
                break;
                
            default:
                break;
        }
        
        [btn addTarget:self action:@selector(qualityButtonClicked:) forControlEvents:UIControlEventTouchUpInside];
        
        [self addSubview:btn];
    }
}


- (void)qualityButtonClicked:(UIButton *)sender{
    

}


/*
// Only override drawRect: if you perform custom drawing.
// An empty implementation adversely affects performance during animation.
- (void)drawRect:(CGRect)rect {
    // Drawing code
}
*/

@end
