//
//  PlayerViewControllerHaveUI.m
//  ALPlayerDemo
//
//  Created by SMY on 16/9/8.
//  Copyright © 2016年 SMY. All rights reserved.
//

#import "DownloadViewController.h"
#import "DownloadListTableViewCell.h"
#import <AliyunVodPlayerSDK/AliyunVodPlayerSDK.h>
#import <AliyunVodPlayerViewSDK/AliyunVodPlayerViewSDK.h>
#import "AddDownloadView.h"
#import "UIView+Layout.h"

#import "DownLoadDataHeader.h"

#define SCREEN_WIDTH  [UIScreen mainScreen].bounds.size.width
#define SCREEN_HEIGHT [UIScreen mainScreen].bounds.size.height

@interface DownloadViewController ()<UITableViewDelegate, UITableViewDataSource,AliyunVodDownLoadDelegate,downloadViewDelegate,cellClickDelegate,AliyunVodPlayerViewDelegate>
{
    AliyunVodPlayerView* _playerView;
}

@property (nonatomic, strong) UITableView *listTableView;
@property (nonatomic, strong) NSMutableArray *listDataArray;
@property (nonatomic, strong) NSMutableArray *listAddArray;
@property (nonatomic, strong) AddDownloadView *downloadView;


@end

@implementation DownloadViewController

@synthesize listTableView;
@synthesize listDataArray;
@synthesize listAddArray;
@synthesize downloadView;

+ (id)sharedViewController{
    static DownloadViewController *VC = nil;
    static dispatch_once_t onceToken;
    dispatch_once(&onceToken, ^{
        VC = [[self alloc] init];
    });
    return VC;
}

#pragma mark - naviBar
- (void)naviBar{
    self.navigationItem.leftBarButtonItem = [[UIBarButtonItem alloc] initWithTitle:@"返回" style:UIBarButtonItemStylePlain target:self action:@selector(leftBarButtonItemCliceked:)];
    self.navigationItem.rightBarButtonItem = [[UIBarButtonItem alloc] initWithTitle:@"添加下载" style:UIBarButtonItemStylePlain target:self action:@selector(rightBarButtonItemCliceked:)];
}

- (void)leftBarButtonItemCliceked:(UIBarButtonItem*)sender{
    
    [_playerView stop];
    [_playerView releasePlayer];
    [_playerView removeFromSuperview];
    _playerView = nil;
    
    [self.navigationController popViewControllerAnimated:YES];
    
}

- (void)rightBarButtonItemCliceked : (UIBarButtonItem *)sender{
    
    [downloadView initShow];
    downloadView.hidden = NO;
}

- (void)viewDidLoad {
    [super viewDidLoad];
    
    [self naviBar];
    
    [self setupSubViews];
    
    self.listDataArray = [NSMutableArray array];
    self.listAddArray = [NSMutableArray array];
    
    
    ///下载必须要设置的三个内容：1.下载代理 2.下载路径3.下载加密的秘钥（如果要加密的话）

    //设置下载代理
    [[AliyunVodDownLoadManager shareManager] setDownloadDelegate:self];
    
    //设置下载路径
    NSString *path = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES)[0];
    [[AliyunVodDownLoadManager shareManager] setDownLoadPath:path];
         
    //设置同时下载的个数
    [[AliyunVodDownLoadManager shareManager] setMaxDownloadOperationCount:3];
}

-(void)viewWillAppear:(BOOL)animated
{
    [super viewWillAppear:animated];
}

-(void) viewWillDisappear:(BOOL)animated
{
    [super viewWillDisappear:animated];
    
//    [self onBackViewClick];
}

-(void)viewDidUnload {
    [super viewDidUnload];
    
//    [self onBackViewClick];
}

- (void)loadListTableView {
    
    self.listTableView = [[UITableView alloc] initWithFrame: CGRectMake(0, 0, SCREEN_WIDTH, SCREEN_HEIGHT)];
    self.listTableView.delegate = self;
    self.listTableView.dataSource = self;
    self.listTableView.separatorStyle = UITableViewCellSeparatorStyleSingleLine;
    [self.listTableView registerClass:[DownloadListTableViewCell class] forCellReuseIdentifier:@"listTableViewID"];
    self.listTableView.tableFooterView = [[UIView alloc] init];
    [self.view addSubview:self.listTableView];
}

-(void)leftBar1Clicked:(NSObject*)sender
{
    [self.navigationController popViewControllerAnimated:YES];
}

- (void)setupSubViews {
    
//    self.navigationController.navigationBar.barTintColor =  [UIColor colorWithRed:0xf2 / 255.0 green:0xf2 / 255.0 blue:0xf2 / 255.0 alpha:1];

    [self loadListTableView];
    
    UIButton* createBtn = [UIButton buttonWithType:(UIButtonTypeRoundedRect)];
    createBtn.frame = CGRectMake((self.view.frame.size.width)/2-110, self.view.frame.size.height-100, 100, 40);
    [createBtn addTarget:self action:@selector(downloadAll:) forControlEvents:(UIControlEventTouchUpInside)];
    [createBtn setTitleColor:[UIColor colorWithRed:123 / 255.0 green:134 / 255.0 blue:252 / 255.0 alpha:1] forState:(UIControlStateNormal)];
    [createBtn setTitleColor:[UIColor grayColor] forState:(UIControlStateSelected)];
    [createBtn.titleLabel setFont:[UIFont systemFontOfSize:17.f]];
    [createBtn setBackgroundColor:[UIColor colorWithRed:0x87 / 255.0 green:0x4b / 255.0 blue:0xe0 / 255.0 alpha:1]];
    [createBtn setTitle:@"全部下载" forState:UIControlStateNormal];
    createBtn.clipsToBounds = YES;
    createBtn.layer.cornerRadius = 20;
    [createBtn setTitleColor:[UIColor whiteColor] forState:UIControlStateNormal];
    [self.view addSubview:createBtn];
    
    UIButton* createBtn1 = [UIButton buttonWithType:(UIButtonTypeRoundedRect)];
    createBtn1.frame = CGRectMake((self.view.frame.size.width)/2+10, self.view.frame.size.height-100, 100, 40);
    [createBtn1 addTarget:self action:@selector(downloadDel:) forControlEvents:(UIControlEventTouchUpInside)];
    [createBtn1 setTitleColor:[UIColor colorWithRed:123 / 255.0 green:134 / 255.0 blue:252 / 255.0 alpha:1] forState:(UIControlStateNormal)];
    [createBtn1 setTitleColor:[UIColor grayColor] forState:(UIControlStateSelected)];
    [createBtn1.titleLabel setFont:[UIFont systemFontOfSize:17.f]];
    [createBtn1 setBackgroundColor:[UIColor colorWithRed:0x87 / 255.0 green:0x4b / 255.0 blue:0xe0 / 255.0 alpha:1]];
    [createBtn1 setTitle:@"全部删除" forState:UIControlStateNormal];
    createBtn1.clipsToBounds = YES;
    createBtn1.layer.cornerRadius = 20;
    [createBtn1 setTitleColor:[UIColor whiteColor] forState:UIControlStateNormal];
    [self.view addSubview:createBtn1];
    
    
    
    downloadView = [[AddDownloadView alloc] initWithFrame:CGRectMake((SCREEN_WIDTH-300)/2, 100, 300, 400)];
    downloadView.hidden = YES;
    [self.view addSubview:downloadView];
    
    downloadView.delegate = self;
}


- (void)downloadAll:(UIButton *)sender{

    [[AliyunVodDownLoadManager shareManager] startDownloadMedias:self.listAddArray];
    
    [listTableView reloadData];


}

- (void)downloadDel:(UIButton *)sender{
    
//    for (downloadCellModel* dcm in self.listDataArray) {
//        AliyunDownloadMediaInfo* downloadInfo = dcm.mInfo;
//            downloadInfo.downloadProgress = 0;
//    }
    [[AliyunVodDownLoadManager shareManager] clearAllMedias];
    [self.listDataArray removeAllObjects];
    [self.listAddArray removeAllObjects];
    [self.listTableView reloadData];
}


- (void)viewDidLayoutSubviews {
    [super viewDidLayoutSubviews];
    if (_playerView)
        [_playerView setNeedsLayout];
}

- (void)dealloc {
    
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
    
    return self.listDataArray.count;
}

- (CGFloat)tableView:(UITableView *)tableView heightForRowAtIndexPath:(NSIndexPath *)indexPath {
    return 100;
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {
    
    DownloadListTableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:@"listTableViewID" forIndexPath:indexPath];
    cell.delegate = self;
    
    if (self.listDataArray.count > indexPath.row) {
        
        downloadCellModel *dcm = self.listDataArray[indexPath.row];
        AliyunDownloadMediaInfo* info = dcm.mInfo;
        cell.mInfo = info;
        cell.mSource = dcm.mSource;
        
        NSString* sizeStr = [[NSString alloc] initWithFormat:@"%@(%.2fM)",info.title,info.size*1.0f/(1024*1024)];
        cell.nameLabel.text = sizeStr;
        
//        cell.progressView.progress = info.downloadProgress*1.0f/100.0f;
        
        int tempProgress =  info.downloadProgress ;
        
        if (tempProgress <= 0 ) {
            cell.progressLabel.text = @"未下载";
        }else if(tempProgress >= 100){
            cell.progressLabel.text = @"已完成";
        }else if (tempProgress > /* DISABLES CODE */ (0) && tempProgress<100) {
            cell.progressLabel.text = [NSString stringWithFormat:@"%.f%%",info.downloadProgress*1.0f];
        }
        
        if(!dcm.mCanStop){
            cell.progressLabel.text = @"已停止";
        }
        
        NSURL* url = [NSURL URLWithString:info.coverURL];
        UIImage* image = [[UIImage alloc] initWithData:[NSData dataWithContentsOfURL:url]];
        [cell.headerImageView setImage:image];
        
        cell.playBtn.enabled = dcm.mCanPlay;
        cell.stopBtn.enabled = dcm.mCanStop;
        cell.startBtn.enabled = dcm.mCanStart;
    }
    
    return cell;
}

-(void)onStartDownload:(AliyunDataSource *)dataSource medianInfo:(AliyunDownloadMediaInfo *)info
{

    for (AliyunDataSource* source in self.listAddArray) {
        if ([dataSource.vid isEqualToString:source.vid] && [dataSource.format isEqualToString:source.format] && dataSource.quality == source.quality) {
            
            UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"提示" message:@"不能重复添加" delegate:nil cancelButtonTitle:@"OK" otherButtonTitles:nil];
            [alert show];
            return;
        }
    }
    
    [self.listAddArray addObject:dataSource];
    downloadCellModel* dcm = [[downloadCellModel alloc] init];
    dcm.mCanStop = YES;
    dcm.mCanPlay =  NO;
    dcm.mCanStart = YES;
    dcm.mInfo = info;
    dcm.mSource = dataSource;
    
    [self.listDataArray addObject:dcm];
    
    [listTableView reloadData];
}

/*
 功能：未完成回调，异常中断导致下载未完成，下次启动后会接收到此回调。
 回调数据：AliyunDownloadMediaInfo数组
 */
-(void)onUnFinished:(NSArray<AliyunDataSource *> *)mediaInfos
{
    NSLog(@"onUnFinished");
    if ([mediaInfos count] > 0) {
        UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"提示" message:@"上次未完成" delegate:nil cancelButtonTitle:@"OK" otherButtonTitles:nil];
        [alert show];
        
        for (AliyunDataSource* source in mediaInfos) {
            
            if (!source.playAuth) {
                source.playAuth = DOWNLOAD_PLAY_AUTH;
            }
    
            downloadCellModel* dcm = [[downloadCellModel alloc] init];
            AliyunDownloadMediaInfo* info = [[AliyunDownloadMediaInfo alloc] init];
            info.vid = source.vid;
            info.quality = source.quality;
            info.format = source.format;
            dcm.mInfo = info;
            dcm.mCanPlay = NO;
            dcm.mCanStop = YES;
            dcm.mCanStart = NO;
            dcm.mSource = source;
            [self.listDataArray addObject:dcm];
            [self.listAddArray addObject:dcm.mSource];
        } 
        [listTableView reloadData];

        [[AliyunVodDownLoadManager shareManager] startDownloadMedias:mediaInfos];
    }
}

/*
 功能：准备下载回调。
 回调数据：AliyunDownloadMediaInfo数组
 */
-(void) onPrepare:(NSArray<AliyunDownloadMediaInfo*>*)mediaInfos
{
    NSLog(@"onPrepare");
    [self.downloadView updateQualityInfo:mediaInfos];
}

/*
 功能：下载开始回调。
 回调数据：AliyunDownloadMediaInfo
 */
-(void) onStart:(AliyunDownloadMediaInfo*)mediaInfo
{
    NSLog(@"onStart");

    for (downloadCellModel* dcm in self.listDataArray) {
        AliyunDownloadMediaInfo* info = dcm.mInfo;
        if (info.quality == mediaInfo.quality && [info.format isEqualToString:mediaInfo.format] && [info.vid isEqualToString:mediaInfo.vid]) {
            info.title = mediaInfo.title;
            info.coverURL = mediaInfo.coverURL;
            info.size = mediaInfo.size;
            info.duration = mediaInfo.duration;
            info.downloadFilePath = mediaInfo.downloadFilePath;
            
            dcm.mCanStop = YES;
            dcm.mCanPlay =  NO;
            dcm.mCanStart =  NO;
            
            [self.listTableView reloadData];
            break;
        }
    }
    UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"提示" message:@"已开始" delegate:nil cancelButtonTitle:@"OK" otherButtonTitles:nil];
    [alert show];
}

/*
 功能：下载进度回调。
 回调数据：AliyunDownloadMediaInfo
 */
-(void) onProgress:(AliyunDownloadMediaInfo*)mediaInfo
{
    for (downloadCellModel* dcm in self.listDataArray) {
        AliyunDownloadMediaInfo* info = dcm.mInfo;
        if ([info.vid isEqualToString:mediaInfo.vid] && [info.format isEqualToString:mediaInfo.format] && info.quality == mediaInfo.quality) {
            info.downloadProgress = mediaInfo.downloadProgress;
            [self.listTableView reloadData];
            break;
        }
    }
    
//    NSArray* array =  [[AliyunVodDownLoadManager shareManager] downloadingdMedias];
//    NSLog(@"%@",array);
}

/*
 功能：下载结束回调。
 回调数据：AliyunDownloadMediaInfo
 */
-(void) onStop:(AliyunDownloadMediaInfo*)mediaInfo
{
    NSLog(@"onStop");
    for (downloadCellModel* dcm in self.listDataArray) {
        if ([dcm.mInfo.vid isEqualToString:mediaInfo.vid] && dcm.mInfo.quality == mediaInfo.quality && [dcm.mInfo.format isEqualToString:mediaInfo.format]) {
            dcm.mCanStop = NO;
            dcm.mCanPlay =  NO;
            dcm.mCanStart =  YES;
            [self.listTableView reloadData];
            break;
        }
    }
    UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"提示" message:@"已停止" delegate:nil cancelButtonTitle:@"OK" otherButtonTitles:nil];
    [alert show];
}

/*
 功能：下载开始回调。
 回调数据：AliyunDownloadMediaInfo
 */
-(void) onCompletion:(AliyunDownloadMediaInfo*)mediaInfo
{
    NSLog(@"onCompletion");
    for (downloadCellModel* dcm in self.listDataArray) {
        if ([dcm.mInfo.vid isEqualToString:mediaInfo.vid] && dcm.mInfo.quality == mediaInfo.quality && [dcm.mInfo.format isEqualToString:mediaInfo.format]) {
            dcm.mCanStop = YES;
            dcm.mCanPlay =  YES;
            dcm.mCanStart =  YES;
            [self.listTableView reloadData];
            break;
        }
    }
    UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"提示" message:@"已完成" delegate:nil cancelButtonTitle:@"OK" otherButtonTitles:nil];
    [alert show];
}

/*
 功能：下载结束回调。错误码与错误信息见下表
 回调数据：AliyunDownloadMediaInfo， code：错误码 msg：错误信息
 */
-(void)onError:(AliyunDownloadMediaInfo*)mediaInfo code:(int)code msg:(NSString *)msg
{
    NSLog(@"onError");
    UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"提示" message:msg delegate:nil cancelButtonTitle:@"OK" otherButtonTitles:nil];
    [alert show];
}

-(NSString*)onGetPlayAuth:(NSString *)vid format:(NSString *)format quality:(AliyunVodPlayerVideoQuality)quality
{
    return DOWNLOAD_PLAY_AUTH;
}

-(void) tableViewCell:(DownloadListTableViewCell *)tableViewCell onClickStart:(AliyunDataSource *)dataSource
{
    [[AliyunVodDownLoadManager shareManager] startDownloadMedia:dataSource];
}

-(void) tableViewCell:(DownloadListTableViewCell *)tableViewCell onClickDelete:(AliyunDownloadMediaInfo*)info
{
    [[AliyunVodDownLoadManager shareManager] clearMedia:info];
    
    for (downloadCellModel* dcm in self.listDataArray) {
        AliyunDownloadMediaInfo* downloadInfo = dcm.mInfo;
        if ([downloadInfo.vid isEqualToString:info.vid] && [downloadInfo.format isEqualToString:info.format] && downloadInfo.quality == info.quality) {
        
            downloadInfo.downloadProgress = 0;
            
            
            
            dcm.mCanPlay = YES;
            dcm.mCanStop = YES;
            dcm.mCanStart = YES;
            [self.listDataArray removeObject:dcm];
            
            [self.listTableView reloadData]; 
            break;
        }
    }
    
    for (AliyunDataSource* source in self.listAddArray) {
        if ([source.vid isEqualToString:info.vid] && [source.format isEqualToString:info.format] && source.quality == info.quality) {
            [self.listAddArray removeObject:source];
            break;
        }
    }
}

-(void) tableViewCell:(DownloadListTableViewCell *)tableViewCell onClickPlay:(AliyunDownloadMediaInfo*)info
{
    if (info.downloadFilePath) {
        [self.navigationController setNavigationBarHidden:YES animated:NO];
        
        if (_playerView) {
            [_playerView removeFromSuperview];
            [_playerView stop];
            [_playerView releasePlayer];
            _playerView = nil;
        }
        
        _playerView = [[AliyunVodPlayerView alloc] initWithFrame:CGRectMake(0, 0, SCREEN_WIDTH, SCREEN_WIDTH * 9 / 16.0)];
        _playerView.delegate = self;
        [_playerView setAutoPlay:YES];
        [self.view addSubview:_playerView];

        [_playerView playViewPrepareWithURL:[NSURL fileURLWithPath:info.downloadFilePath]];
    }
}

- (void)onBackViewClickWithAliyunVodPlayerView:(AliyunVodPlayerView *)playerView{
    [self.navigationController setNavigationBarHidden:NO animated:NO];
    if (_playerView) {
        [_playerView removeFromSuperview];
        [_playerView stop];
        [_playerView releasePlayer];
        _playerView = nil;
    }
}


-(void) tableViewCell:(DownloadListTableViewCell *)tableViewCell onClickStop:(AliyunDownloadMediaInfo*)info
{
    [[AliyunVodDownLoadManager shareManager] stopDownloadMedia:info];
}



@end
