//
//  ViewController.m
//  AliyunPlayerMediaDemo
//
//  Created by 王凯 on 2017/8/14.
//  Copyright © 2017年 com.alibaba.ALPlayerVodSDK. All rights reserved.
//

#import "ViewController.h"
#import "AppDelegate.h"
#import "AddPlayView.h"

#import "AliyunPlaySDKDemoOneViewController.h"

#import "AliyunPlaySDKListsAutoViewController.h"
#import "AliyunPlaySDKDemoFullScreenScrollViewController.h"
#import "AliyunPlayerMediaDownloadsViewController.h"
#import "DownloadViewController.h"
#import "ALiyunPlaySDKCheckToolViewController.h"
#import "AliyunPlayerMediaUIDemoViewController.h"


@interface ViewController ()<UITableViewDelegate,UITableViewDataSource,addPlayDelegate>
{
    AddPlayView* mAddView;
}

@property(nonatomic, strong )UITableView *tableView;

@property(nonatomic, strong)NSArray *titlesAry;

@end

@implementation ViewController

-(NSArray *)titlesAry
{
    if (!_titlesAry) {
        _titlesAry = @[@"点播播放功能(vid+playAuth方式演示)",
                       @"多视频列表自动播放(url方式演示)",
                       @"全屏滑动切换播放(url方式演示)",
                       @"多视频断点下载演示",
                       @"完整UI播放器基本功能演示",
                       ];
    }
    return _titlesAry;
}

-(UITableView *)tableView
{
    if (!_tableView) {
        _tableView = [[UITableView alloc]initWithFrame:CGRectZero style:UITableViewStylePlain];
        _tableView.delegate = self;
        _tableView.dataSource = self;
        _tableView.scrollEnabled = NO;
        UIView *footview = [[UIView alloc] initWithFrame:CGRectZero];
        _tableView.tableFooterView = footview;
        
    }
    return  _tableView;
}


- (void)initView{
    
    [self.view addSubview:self.tableView];
    
    
}

- (void)viewDidLoad {
    [super viewDidLoad];
    self.navigationItem.title =  @"播放器场景列表";
    self.edgesForExtendedLayout = UIRectEdgeNone;
    
    [self initView];
    mAddView = [[AddPlayView alloc] initWithFrame:CGRectMake(([UIScreen mainScreen].bounds.size.width-300)/2, 100, 300, 400)];
    mAddView.hidden = YES;
    mAddView.delegate = self;
    [self.view addSubview:mAddView];

    // Do any additional setup after loading the view, typically from a nib.
}

-(void)viewWillAppear:(BOOL)animated{
    [super viewWillAppear:animated];
    self.navigationController.navigationBar.hidden  = NO;
}

-(void)viewWillLayoutSubviews{
    [super viewWillLayoutSubviews];
    self.tableView.frame = CGRectMake(0, 0, self.view.bounds.size.width, self.view.bounds.size.height);
}

#pragma mark - tableDelegate/datasource
-(NSInteger)numberOfSectionsInTableView:(UITableView *)tableView{
    return 1;
}

-(NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
    return  self.titlesAry.count;
}

-(void)onClickAddPlay:(int)clickType vid:(NSString *)vid playAuth:(NSString *)playAuth{
    //无UI
    if (clickType == 0) {
        AliyunPlaySDKDemoOneViewController *demoOne = [self.storyboard instantiateViewControllerWithIdentifier:@"AliyunPlaySDKDemoOneViewController"];
        [demoOne setPlaySource:vid playAuth:playAuth];
        [self.navigationController pushViewController:demoOne animated:YES];
    }
    else if(clickType == 1){
        AliyunPlayerMediaUIDemoViewController *demoFive = [[AliyunPlayerMediaUIDemoViewController alloc] init];
        [demoFive setPlaySource:vid playAuth:playAuth];
        [self presentViewController:demoFive animated:YES completion:nil];
    }
}

-(UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath{
    static NSString *cellIdentifier = @"democell";
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:cellIdentifier];\
    if (!cell) {
        cell = [[UITableViewCell alloc] initWithStyle:UITableViewCellStyleDefault reuseIdentifier:cellIdentifier];
    }
    
    cell.textLabel.text = self.titlesAry[indexPath.row];
    cell.textLabel.font = [UIFont systemFontOfSize:15.0f];
    cell.accessoryType=UITableViewCellAccessoryDisclosureIndicator;
    
    return cell;
    
}


-(void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(nonnull NSIndexPath *)indexPath{
    
    switch (indexPath.row) {
        
        case 0:
        {
            /*********点播播放功能(vid+playAuth方式演示)**********/
            mAddView.hidden = NO;
            [mAddView setAddPlayType:0];
        }
        break;

        case 1:
        {
            /*********多视频列表自动播放(url方式演示)**********/
            AliyunPlaySDKListsAutoViewController *demoTwo = [[AliyunPlaySDKListsAutoViewController alloc]     init];
            demoTwo.title = self.titlesAry[indexPath.row];
            [self.navigationController pushViewController:demoTwo animated:YES];
            
        }
            break;
        
        case 2:
        {
            /*********全屏滑动切换播放(url方式演示)***********/
            AliyunPlaySDKDemoFullScreenScrollViewController *demoThree = [[AliyunPlaySDKDemoFullScreenScrollViewController alloc] init];
            demoThree.title = self.titlesAry[indexPath.row];
            [self.navigationController pushViewController:demoThree animated:YES];
        }
            break;
        
        case 3 :
        {
            /*********多视频断点下载演示*********************/
            DownloadViewController *demoFour =  [DownloadViewController sharedViewController];
            demoFour.title = self.titlesAry[indexPath.row];
            [self.navigationController pushViewController:demoFour animated:YES];
            
        }
            break;
        case 4:
        {
            /*********完整UI播放器基本功能演示***************/
            mAddView.hidden = NO;
            [mAddView setAddPlayType:1];
        }
            break;
        
            
            
        default:
            break;
    }
    
    [tableView deselectRowAtIndexPath:indexPath animated:YES];
    
}







- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

@end
